<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: dlib::queue_kernel_1&lt; T, mem_manager &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacedlib.html">dlib</a></li><li class="navelem"><a class="el" href="classdlib_1_1queue__kernel__1.html">queue_kernel_1</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pri-methods">Private Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="classdlib_1_1queue__kernel__1-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">dlib::queue_kernel_1&lt; T, mem_manager &gt; Class Template Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="dynheader">
Inheritance diagram for dlib::queue_kernel_1&lt; T, mem_manager &gt;:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classdlib_1_1queue__kernel__1.png" usemap="#dlib::queue_5Fkernel_5F1_3C_20T_2C_20mem_5Fmanager_20_3E_map" alt=""/>
  <map id="dlib::queue_5Fkernel_5F1_3C_20T_2C_20mem_5Fmanager_20_3E_map" name="dlib::queue_5Fkernel_5F1_3C_20T_2C_20mem_5Fmanager_20_3E_map">
<area href="classdlib_1_1enumerable.html" alt="dlib::enumerable&lt; T &gt;" shape="rect" coords="0,0,249,24"/>
<area href="classdlib_1_1remover.html" alt="dlib::remover&lt; T &gt;" shape="rect" coords="259,0,508,24"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structdlib_1_1queue__kernel__1_1_1node.html">node</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:a6f1082db5eacd185cbe6b2c0a44af27b"><td class="memItemLeft" align="right" valign="top"><a id="a6f1082db5eacd185cbe6b2c0a44af27b"></a>
typedef T&#160;</td><td class="memItemRight" valign="bottom"><b>type</b></td></tr>
<tr class="separator:a6f1082db5eacd185cbe6b2c0a44af27b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a714f579ac8f981ca5b693dcbabb16b2b"><td class="memItemLeft" align="right" valign="top"><a id="a714f579ac8f981ca5b693dcbabb16b2b"></a>
typedef mem_manager&#160;</td><td class="memItemRight" valign="bottom"><b>mem_manager_type</b></td></tr>
<tr class="separator:a714f579ac8f981ca5b693dcbabb16b2b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_types_classdlib_1_1enumerable"><td colspan="2" onclick="javascript:toggleInherit('pub_types_classdlib_1_1enumerable')"><img src="closed.png" alt="-"/>&#160;Public Types inherited from <a class="el" href="classdlib_1_1enumerable.html">dlib::enumerable&lt; T &gt;</a></td></tr>
<tr class="memitem:aece453aca3947d8b1f7bf016d5f99cda inherit pub_types_classdlib_1_1enumerable"><td class="memItemLeft" align="right" valign="top">typedef T&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1enumerable.html#aece453aca3947d8b1f7bf016d5f99cda">type</a></td></tr>
<tr class="separator:aece453aca3947d8b1f7bf016d5f99cda inherit pub_types_classdlib_1_1enumerable"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_types_classdlib_1_1remover"><td colspan="2" onclick="javascript:toggleInherit('pub_types_classdlib_1_1remover')"><img src="closed.png" alt="-"/>&#160;Public Types inherited from <a class="el" href="classdlib_1_1remover.html">dlib::remover&lt; T &gt;</a></td></tr>
<tr class="memitem:a717e9bdbd0335036d142080dbac7d66d inherit pub_types_classdlib_1_1remover"><td class="memItemLeft" align="right" valign="top">typedef T&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1remover.html#a717e9bdbd0335036d142080dbac7d66d">type</a></td></tr>
<tr class="separator:a717e9bdbd0335036d142080dbac7d66d inherit pub_types_classdlib_1_1remover"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:afe70889d0192c92f99a7b7c932b7f120"><td class="memItemLeft" align="right" valign="top"><a id="afe70889d0192c92f99a7b7c932b7f120"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>clear</b> ()</td></tr>
<tr class="separator:afe70889d0192c92f99a7b7c932b7f120"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5fe4345361773ae6d3d55e05e27ba0e0"><td class="memItemLeft" align="right" valign="top"><a id="a5fe4345361773ae6d3d55e05e27ba0e0"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>enqueue</b> (T &amp;item)</td></tr>
<tr class="separator:a5fe4345361773ae6d3d55e05e27ba0e0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aba3ed4f6ca48869e6e6b599d8b421a7c"><td class="memItemLeft" align="right" valign="top"><a id="aba3ed4f6ca48869e6e6b599d8b421a7c"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>dequeue</b> (T &amp;item)</td></tr>
<tr class="separator:aba3ed4f6ca48869e6e6b599d8b421a7c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a55c1775e6539fea79742cf3d8f137ae2"><td class="memItemLeft" align="right" valign="top"><a id="a55c1775e6539fea79742cf3d8f137ae2"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>cat</b> (<a class="el" href="classdlib_1_1queue__kernel__1.html">queue_kernel_1</a> &amp;item)</td></tr>
<tr class="separator:a55c1775e6539fea79742cf3d8f137ae2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af9cc4db6381b7d6f4dd89d23a65faed2"><td class="memItemLeft" align="right" valign="top"><a id="af9cc4db6381b7d6f4dd89d23a65faed2"></a>
T &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>current</b> ()</td></tr>
<tr class="separator:af9cc4db6381b7d6f4dd89d23a65faed2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0507c94da27bb0c90afd70ee9fe64dfc"><td class="memItemLeft" align="right" valign="top"><a id="a0507c94da27bb0c90afd70ee9fe64dfc"></a>
const T &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>current</b> () const</td></tr>
<tr class="separator:a0507c94da27bb0c90afd70ee9fe64dfc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afeac09283b86088ad931c39794e12ae9"><td class="memItemLeft" align="right" valign="top"><a id="afeac09283b86088ad931c39794e12ae9"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>swap</b> (<a class="el" href="classdlib_1_1queue__kernel__1.html">queue_kernel_1</a> &amp;item)</td></tr>
<tr class="separator:afeac09283b86088ad931c39794e12ae9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa276c1e2716ecd0dcc70548c0c4f1c50"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1queue__kernel__1.html#aa276c1e2716ecd0dcc70548c0c4f1c50">remove_any</a> (T &amp;item)</td></tr>
<tr class="separator:aa276c1e2716ecd0dcc70548c0c4f1c50"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a26530b6cc305b3a3c5ab2cf13f429e12"><td class="memItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1queue__kernel__1.html#a26530b6cc305b3a3c5ab2cf13f429e12">size</a> () const</td></tr>
<tr class="separator:a26530b6cc305b3a3c5ab2cf13f429e12"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5358361b2b24a0dbe7365263d83fd886"><td class="memItemLeft" align="right" valign="top"><a id="a5358361b2b24a0dbe7365263d83fd886"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>at_start</b> () const</td></tr>
<tr class="separator:a5358361b2b24a0dbe7365263d83fd886"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab66842cdf3174953c4f18fc038cbff20"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1queue__kernel__1.html#ab66842cdf3174953c4f18fc038cbff20">reset</a> () const</td></tr>
<tr class="separator:ab66842cdf3174953c4f18fc038cbff20"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a82eb8c649ae544833705487e6a484e03"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1queue__kernel__1.html#a82eb8c649ae544833705487e6a484e03">current_element_valid</a> () const</td></tr>
<tr class="separator:a82eb8c649ae544833705487e6a484e03"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae22883ff878b870b2e566011cb503eb8"><td class="memItemLeft" align="right" valign="top">const T &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1queue__kernel__1.html#ae22883ff878b870b2e566011cb503eb8">element</a> () const</td></tr>
<tr class="separator:ae22883ff878b870b2e566011cb503eb8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac50be65cae6e41aba3769a7791e82dd6"><td class="memItemLeft" align="right" valign="top">T &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1queue__kernel__1.html#ac50be65cae6e41aba3769a7791e82dd6">element</a> ()</td></tr>
<tr class="separator:ac50be65cae6e41aba3769a7791e82dd6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa712ccf7e2b0651526cffb6b23c453d9"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1queue__kernel__1.html#aa712ccf7e2b0651526cffb6b23c453d9">move_next</a> () const</td></tr>
<tr class="separator:aa712ccf7e2b0651526cffb6b23c453d9"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr class="memitem:aa98fb280acca75212cfdf9c386de03df"><td class="memItemLeft" align="right" valign="top"><a id="aa98fb280acca75212cfdf9c386de03df"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>delete_nodes</b> (<a class="el" href="structdlib_1_1queue__kernel__1_1_1node.html">node</a> *start, unsigned long length)</td></tr>
<tr class="separator:aa98fb280acca75212cfdf9c386de03df"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a04bf3de035169ad60802d9f136f2e3b9"><td class="memItemLeft" align="right" valign="top"><a id="a04bf3de035169ad60802d9f136f2e3b9"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>queue_kernel_1</b> (<a class="el" href="classdlib_1_1queue__kernel__1.html">queue_kernel_1</a> &amp;)</td></tr>
<tr class="separator:a04bf3de035169ad60802d9f136f2e3b9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a58052fc2d60a7a65ecf1c15d97e0258e"><td class="memItemLeft" align="right" valign="top"><a id="a58052fc2d60a7a65ecf1c15d97e0258e"></a>
<a class="el" href="classdlib_1_1queue__kernel__1.html">queue_kernel_1</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator=</b> (<a class="el" href="classdlib_1_1queue__kernel__1.html">queue_kernel_1</a> &amp;)</td></tr>
<tr class="separator:a58052fc2d60a7a65ecf1c15d97e0258e"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:ad76cee2335ecde67b20408212e1f4dd3"><td class="memItemLeft" align="right" valign="top"><a class="el" href="structdlib_1_1queue__kernel__1_1_1node.html">node</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1queue__kernel__1.html#ad76cee2335ecde67b20408212e1f4dd3">in</a></td></tr>
<tr class="separator:ad76cee2335ecde67b20408212e1f4dd3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3f31c0a60d9546f06e77df3febb72e80"><td class="memItemLeft" align="right" valign="top"><a id="a3f31c0a60d9546f06e77df3febb72e80"></a>
<a class="el" href="structdlib_1_1queue__kernel__1_1_1node.html">node</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>out</b></td></tr>
<tr class="separator:a3f31c0a60d9546f06e77df3febb72e80"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2184f1180d6fbbd8ca7864517ef5c0f9"><td class="memItemLeft" align="right" valign="top"><a id="a2184f1180d6fbbd8ca7864517ef5c0f9"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>queue_size</b></td></tr>
<tr class="separator:a2184f1180d6fbbd8ca7864517ef5c0f9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2dd98d5c6a61fdd91d978a6b876f6a6f"><td class="memItemLeft" align="right" valign="top"><a id="a2dd98d5c6a61fdd91d978a6b876f6a6f"></a>
<a class="el" href="structdlib_1_1queue__kernel__1_1_1node.html">node</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>current_element</b></td></tr>
<tr class="separator:a2dd98d5c6a61fdd91d978a6b876f6a6f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a22d16759255f17d3fd83b9777ae70f6c"><td class="memItemLeft" align="right" valign="top"><a id="a22d16759255f17d3fd83b9777ae70f6c"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>at_start_</b></td></tr>
<tr class="separator:a22d16759255f17d3fd83b9777ae70f6c"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pro_methods_classdlib_1_1enumerable"><td colspan="2" onclick="javascript:toggleInherit('pro_methods_classdlib_1_1enumerable')"><img src="closed.png" alt="-"/>&#160;Protected Member Functions inherited from <a class="el" href="classdlib_1_1enumerable.html">dlib::enumerable&lt; T &gt;</a></td></tr>
<tr class="memitem:a328c55c7c5df14e115cd502e9756e8a3 inherit pro_methods_classdlib_1_1enumerable"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classdlib_1_1enumerable.html">enumerable</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1enumerable.html#a328c55c7c5df14e115cd502e9756e8a3">operator=</a> (const <a class="el" href="classdlib_1_1enumerable.html">enumerable</a> &amp;)</td></tr>
<tr class="separator:a328c55c7c5df14e115cd502e9756e8a3 inherit pro_methods_classdlib_1_1enumerable"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pro_methods_classdlib_1_1remover"><td colspan="2" onclick="javascript:toggleInherit('pro_methods_classdlib_1_1remover')"><img src="closed.png" alt="-"/>&#160;Protected Member Functions inherited from <a class="el" href="classdlib_1_1remover.html">dlib::remover&lt; T &gt;</a></td></tr>
<tr class="memitem:a58be6630e553c7f4d14dd4c4c2b4c859 inherit pro_methods_classdlib_1_1remover"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classdlib_1_1remover.html">remover</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1remover.html#a58be6630e553c7f4d14dd4c4c2b4c859">operator=</a> (const <a class="el" href="classdlib_1_1remover.html">remover</a> &amp;)</td></tr>
<tr class="separator:a58be6630e553c7f4d14dd4c4c2b4c859 inherit pro_methods_classdlib_1_1remover"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a82eb8c649ae544833705487e6a484e03"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a82eb8c649ae544833705487e6a484e03">&#9670;&nbsp;</a></span>current_element_valid()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classdlib_1_1queue__kernel__1.html">dlib::queue_kernel_1</a>&lt; T, mem_manager &gt;::current_element_valid </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - #current_element_valid() == false 
    - #at_start() == true
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#a1d8826bb2077f454da01103773f892c6">dlib::enumerable&lt; T &gt;</a>.</p>

</div>
</div>
<a id="ac50be65cae6e41aba3769a7791e82dd6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac50be65cae6e41aba3769a7791e82dd6">&#9670;&nbsp;</a></span>element() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">T &amp; <a class="el" href="classdlib_1_1queue__kernel__1.html">dlib::queue_kernel_1</a>&lt; T, mem_manager &gt;::element </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - current_element_valid() == true
ensures
    - returns a const reference to the current element
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#a43a289e594edbf10a8300f5b49569524">dlib::enumerable&lt; T &gt;</a>.</p>

</div>
</div>
<a id="ae22883ff878b870b2e566011cb503eb8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae22883ff878b870b2e566011cb503eb8">&#9670;&nbsp;</a></span>element() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const T &amp; <a class="el" href="classdlib_1_1queue__kernel__1.html">dlib::queue_kernel_1</a>&lt; T, mem_manager &gt;::element </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - returns true if we are currently at a valid element else
      returns false 
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#ac8b8efc630a1ee6abe6ba2a153bf0047">dlib::enumerable&lt; T &gt;</a>.</p>

</div>
</div>
<a id="aa712ccf7e2b0651526cffb6b23c453d9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa712ccf7e2b0651526cffb6b23c453d9">&#9670;&nbsp;</a></span>move_next()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classdlib_1_1queue__kernel__1.html">dlib::queue_kernel_1</a>&lt; T, mem_manager &gt;::move_next </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - current_element_valid() == true
ensures
    - returns a non-const reference to the current element
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#a1b204b94acddc602ed8750731c7550ce">dlib::enumerable&lt; T &gt;</a>.</p>

</div>
</div>
<a id="aa276c1e2716ecd0dcc70548c0c4f1c50"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa276c1e2716ecd0dcc70548c0c4f1c50">&#9670;&nbsp;</a></span>remove_any()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classdlib_1_1queue__kernel__1.html">dlib::queue_kernel_1</a>&lt; T, mem_manager &gt;::remove_any </td>
          <td>(</td>
          <td class="paramtype">T &amp;&#160;</td>
          <td class="paramname"><em>item</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - all resources associated with *this have been released.
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1remover.html#a80c7e7417e08a66ca361f646a12aaa03">dlib::remover&lt; T &gt;</a>.</p>

</div>
</div>
<a id="ab66842cdf3174953c4f18fc038cbff20"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab66842cdf3174953c4f18fc038cbff20">&#9670;&nbsp;</a></span>reset()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classdlib_1_1queue__kernel__1.html">dlib::queue_kernel_1</a>&lt; T, mem_manager &gt;::reset </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - returns true if *this represents one position before the first element
      in the container (this would also make the current element invalid) 
      else returns false                
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#a2904ebf4bc18e60b5669509416827a3e">dlib::enumerable&lt; T &gt;</a>.</p>

</div>
</div>
<a id="a26530b6cc305b3a3c5ab2cf13f429e12"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a26530b6cc305b3a3c5ab2cf13f429e12">&#9670;&nbsp;</a></span>size()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">unsigned long <a class="el" href="classdlib_1_1queue__kernel__1.html">dlib::queue_kernel_1</a>&lt; T, mem_manager &gt;::size </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - moves to the next element.  i.e. #element() will now 
      return the next element in the container 
    - the return value will be equal to #current_element_valid() 
    - #at_start() == false 

    - returns true if there is another element 
    - returns false if there are no more elements in the container
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#a3181bdae2392e004881efe86bb2cd412">dlib::enumerable&lt; T &gt;</a>.</p>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="ad76cee2335ecde67b20408212e1f4dd3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad76cee2335ecde67b20408212e1f4dd3">&#9670;&nbsp;</a></span>in</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T, typename mem_manager = default_memory_manager&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structdlib_1_1queue__kernel__1_1_1node.html">node</a>* <a class="el" href="classdlib_1_1queue__kernel__1.html">dlib::queue_kernel_1</a>&lt; T, mem_manager &gt;::in</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - start points to a node in a singly linked list 
    - start-&gt;last points to the next node in the list 
    - there are at least length nodes in the list begining with start
ensures
    - length nodes have been deleted starting with the node pointed 
      to by start
</pre><p> ! </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="queue__kernel__1_8h_source.html">queue_kernel_1.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
